=== modified file 'TODO'
--- TODO	2011-12-25 00:43:51 +0000
+++ TODO	2011-12-21 00:33:12 +0000
@@ -1,10 +1,14 @@
 -*- org -*-
 
+* Use _attribute_((nonnull)) wherever possible.
+
 * [[http://www.undeadly.org/cgi?action=article&sid=20110530221728][OpenBSD]]
 
 * mandos-applet
 
 * mandos-client
+** TODO [#B] Flag fprintf_plus so compiler checks the format string.
+** TODO [#A] OpenVPN network hook
 ** TODO [#A] Wireless network hook
 ** TODO [#B] Use capabilities instead of seteuid().
 ** TODO [#B] Use struct sockaddr_storage instead of a union
@@ -41,6 +45,7 @@
 * mandos (server)
 ** TODO Document why we ignore sigint
 ** TODO [#B] Log level							  :BUGS:
+** TODO [#A] Save state to new file and move instead of overwrite  
 *** TODO /etc/mandos/clients.d/*.conf
     Watch this directory and add/remove/update clients?
 ** TODO [#C] config for TXT record
@@ -77,6 +82,7 @@
 *** Handle "no D-Bus server" and/or "no Mandos server found" better
 *** [#B] --dump option
 ** TODO Support RFC 3339 time duration syntax
+** TODO Send milliseconds if bare integer is passed as time duration
 
 * TODO mandos-dispatch
   Listens for specified D-Bus signals and spawns shell commands with

=== modified file 'mandos'
--- mandos	2011-12-23 20:00:52 +0000
+++ mandos	2011-12-21 16:33:08 +0000
@@ -110,7 +110,7 @@
         return interface_index
 
 
-def initlogger(debug, level=logging.WARNING):
+def initlogger(level=logging.WARNING):
     """init logger and add loglevel"""
     
     syslogger.setFormatter(logging.Formatter
@@ -118,13 +118,12 @@
                             ' %(message)s'))
     logger.addHandler(syslogger)
     
-    if debug:
-        console = logging.StreamHandler()
-        console.setFormatter(logging.Formatter('%(asctime)s %(name)s'
-                                               ' [%(process)d]:'
-                                               ' %(levelname)s:'
-                                               ' %(message)s'))
-        logger.addHandler(console)
+    console = logging.StreamHandler()
+    console.setFormatter(logging.Formatter('%(asctime)s %(name)s'
+                                           ' [%(process)d]:'
+                                           ' %(levelname)s:'
+                                           ' %(message)s'))
+    logger.addHandler(console)
     logger.setLevel(level)
 
 
@@ -2079,13 +2078,13 @@
                                      stored_state_file)
     
     if debug:
-        initlogger(debug, logging.DEBUG)
+        initlogger(logging.DEBUG)
     else:
         if not debuglevel:
-            initlogger(debug)
+            initlogger()
         else:
             level = getattr(logging, debuglevel.upper())
-            initlogger(debug, level)
+            initlogger(level)
     
     if server_settings["servicename"] != "Mandos":
         syslogger.setFormatter(logging.Formatter
@@ -2157,6 +2156,9 @@
         os.dup2(null, sys.stdin.fileno())
         if null > 2:
             os.close(null)
+    else:
+        # No console logging
+        logger.removeHandler(console)
     
     # Need to fork before connecting to D-Bus
     if not debug:
@@ -2216,9 +2218,6 @@
                            .format(e))
             if e.errno != errno.ENOENT:
                 raise
-        except EOFError as e:
-            logger.warning("Could not load persistent state: "
-                           "EOFError: {0}".format(e))
     
     with PGPEngine() as pgp:
         for client_name, client in clients_data.iteritems():
@@ -2403,24 +2402,15 @@
                 del client_settings[client.name]["secret"]
         
         try:
-            tempfd, tempname = tempfile.mkstemp(suffix=".pickle",
-                                                prefix="clients-",
-                                                dir=os.path.dirname
-                                                (stored_state_path))
-            with os.fdopen(tempfd, "wb") as stored_state:
+            with os.fdopen(os.open(stored_state_path,
+                                   os.O_CREAT|os.O_WRONLY|os.O_TRUNC,
+                                   0600), "wb") as stored_state:
                 pickle.dump((clients, client_settings), stored_state)
-            os.rename(tempname, stored_state_path)
         except (IOError, OSError) as e:
             logger.warning("Could not save persistent state: {0}"
                            .format(e))
-            if not debug:
-                try:
-                    os.remove(tempname)
-                except NameError:
-                    pass
-            if e.errno not in set((errno.ENOENT, errno.EACCES,
-                                   errno.EEXIST)):
-                raise e
+            if e.errno not in (errno.ENOENT, errno.EACCES):
+                raise
         
         # Delete all clients, and settings from config
         while tcp_server.clients:

=== modified file 'mandos-ctl'
--- mandos-ctl	2011-12-21 17:17:32 +0000
+++ mandos-ctl	2011-12-21 00:29:33 +0000
@@ -236,7 +236,7 @@
             #restore stderr
             os.dup2(stderrcopy, sys.stderr.fileno())
             os.close(stderrcopy)
-    except dbus.exceptions.DBusException:
+    except dbus.exceptions.DBusException, e:
         print("Access denied: Accessing mandos server through dbus.",
               file=sys.stderr)
         sys.exit(1)

=== modified file 'network-hooks.d/bridge'
--- network-hooks.d/bridge	2011-12-27 03:56:39 +0000
+++ network-hooks.d/bridge	2011-11-28 23:40:46 +0000
@@ -41,9 +41,9 @@
 	"$brctl" addbr "$BRIDGE"
 	for port in $PORTS; do
 	    "$brctl" addif "$BRIDGE" "$port"
-	    ip link set dev "$port" up
+	    ip link set up "$port"
 	done
-	ip link set dev "$BRIDGE" up
+	ip link set up "$BRIDGE"
 	sleep "$DELAY"
 	if [ -n "$IPADDRS" ]; then
             for ipaddr in $IPADDRS; do
@@ -57,9 +57,9 @@
 	fi
 	;;
     stop)
-	ip link set dev "$BRIDGE" down
+	ip link set down "$BRIDGE"
 	for port in $PORTS; do
-	    ip link set dev "$port" down
+	    ip link set down "$port"
 	    "$brctl" delif "$BRIDGE" "$port"
 	done
 	"$brctl" delbr "$BRIDGE"

=== removed file 'network-hooks.d/wireless'
--- network-hooks.d/wireless	2011-12-30 17:57:46 +0000
+++ network-hooks.d/wireless	1970-01-01 00:00:00 +0000
@@ -1,136 +0,0 @@
-#!/bin/sh
-#
-# This is an example of a Mandos client network hook.  This hook
-# brings up a wireless interface as specified in a separate
-# configuration file.  To be used, this file and any needed
-# configuration file(s) should be copied into the
-# /etc/mandos/network-hooks.d directory.
-# 
-# Copying and distribution of this file, with or without modification,
-# are permitted in any medium without royalty provided the copyright
-# notice and this notice are preserved.  This file is offered as-is,
-# without any warranty.
-
-set -e
-
-RUNDIR="/run"
-CTRL="$RUNDIR/wpa_supplicant-global"
-CTRLDIR="$RUNDIR/wpa_supplicant"
-PIDFILE="$RUNDIR/wpa_supplicant-mandos.pid"
-
-CONFIG="$MANDOSNETHOOKDIR/wireless.conf"
-
-# Read config file
-if [ -e "$CONFIG" ]; then
-    . "$CONFIG"
-else
-    exit
-fi
-
-interfaces="`env|sed -n -e 's/^\(MODULE\|IPADDRS\|ROUTES\|WPA_DRIVER\)_\([^=]*\)=.*/\2/p' \"$CONFIG\" |sort -u`"
-
-# Exit if DEVICE is set and is not any of the wireless interfaces
-if [ -n "$DEVICE" ]; then
-    while :; do
-	for IF in $interfaces; do
-	    if [ "$IF" = "$DEVICE" ]; then
-		break 2
-	    fi
-	done
-	exit
-    done
-fi
-
-wpa_supplicant=/sbin/wpa_supplicant
-wpa_cli=/sbin/wpa_cli
-ip=/bin/ip
-
-# Used by the wpa_interface_* functions in the wireless.conf file
-wpa_cli_set(){
-    case "$1" in
-        ssid|psk) arg="\"$2\"" ;;
-        *) arg="$2" ;;
-    esac
-    "$wpa_cli" -p "$CTRLDIR" -i "$INTERFACE" set_network "$NETWORK" \
-	"$1" "$arg" 2>&1 | sed -e '/^OK$/d'
-}
-
-if [ $VERBOSITY -gt 0 ]; then
-    WPAS_OPTIONS="-d $WPAS_OPTIONS"
-fi
-if [ -n "$PIDFILE" ]; then
-    WPAS_OPTIONS="-P$PIDFILE $WPAS_OPTIONS"
-fi
-
-case "${MODE:-$1}" in
-    start)
-	mkdir -m u=rwx,go= -p "$CTRLDIR"
-	"$wpa_supplicant" -B -g "$CTRL" -p "$CTRLDIR" $WPAS_OPTIONS
-        for INTERFACE in $interfaces; do
-	    DRIVER=`eval 'echo "$WPA_DRIVER_'"$INTERFACE"\"`
-	    IFDELAY=`eval 'echo "$DELAY_'"$INTERFACE"\"`
-	    "$wpa_cli" -g "$CTRL" interface_add "$INTERFACE" "" \
-		"${DRIVER:-wext}" "$CTRLDIR" > /dev/null \
-		| sed -e '/^OK$/d'
-	    NETWORK=`"$wpa_cli" -p "$CTRLDIR" -i "$INTERFACE" add_network`
-	    eval wpa_interface_"$INTERFACE"
-	    "$wpa_cli" -p "$CTRLDIR" -i "$INTERFACE" enable_network \
-		"$NETWORK" | sed -e '/^OK$/d'
-	    ( sleep "${IFDELAY:-$DELAY}" || : ) &
-	    sleep=$!
-	    while :; do
-		kill -0 $sleep 2>/dev/null || break
-		STATE=`"$wpa_cli" -p "$CTRLDIR" -i "$INTERFACE" status | sed -n -e 's/^wpa_state=//p'`
-		if [ "$STATE" = COMPLETED ]; then
-		    kill $sleep 2>/dev/null
-		    break
-		fi
-		sleep 1
-	    done &
-	    wait $sleep || :
-	    IPADDRS=`eval 'echo "$IPADDRS_'"$INTERFACE"\"`
-	    if [ -n "$IPADDRS" ]; then
-		if [ "$IPADDRS" = dhcp ]; then
-		    ipconfig -c dhcp -d "$INTERFACE" || :
-		    #dhclient "$INTERFACE"
-		else
-		    for ipaddr in $IPADDRS; do
-			"$ip" addr add "$ipaddr" dev "$INTERFACE"
-		    done
-		fi
-	    fi
-	    ROUTES=`eval 'echo "$ROUTES_'"$INTERFACE"\"`
-	    if [ -n "$ROUTES" ]; then
-		for route in $ROUTES; do
-		    "$ip" route add "$route" dev "$BRIDGE"
-		done
-	    fi
-        done
-	;;
-    stop)
-	"$wpa_cli" -g "$CTRL" terminate 2>&1 | sed -e '/^OK$/d'
-        for INTERFACE in $interfaces; do
-	    "$ip" addr show scope global permanent dev "$INTERFACE" \
-		| while read type addr rest; do
-		case "$type" in
-		    inet|inet6)
-			"$ip" addr del "$addr" dev "$INTERFACE"
-			;;
-		esac
-	    done
-	    "$ip" link set dev "$INTERFACE" down
-	done
-	;;
-    files)
-	echo "$wpa_supplicant"
-	echo "$wpa_cli"
-	echo "$ip"
-	;;
-    modules)
-	if [ "$IPADDRS" = dhcp ]; then
-	    echo af_packet
-	fi
-	sed -n -e 's/#.*$//' -e 's/[ 	]*$//' \
-	    -e 's/^MODULE_[^=]\+=//p' "$CONFIG"
-	;;
-esac

=== removed file 'network-hooks.d/wireless.conf'
--- network-hooks.d/wireless.conf	2011-12-27 03:56:39 +0000
+++ network-hooks.d/wireless.conf	1970-01-01 00:00:00 +0000
@@ -1,17 +0,0 @@
-# Extra options for wpa_supplicant, if any
-#WPAS_OPTIONS=""
-
-# wlan0
-MODULE_wlan0=ath9k
-#WPA_DRIVER_wlan0=wext
-wpa_interface_wlan0(){
-    # Use this format to set simple things:
-    wpa_cli_set ssid home
-    wpa_cli_set psk "secret passphrase"
-    # Use this format to do more complex things with wpa_cli:
-    #"$wpa_cli" -p "$CTRLDIR" -i "$INTERFACE" set_network "$NETWORK" passphrase '"secret passphrase"'
-}
-#DELAY_wlan0=10
-IPADDRS_wlan0=dhcp
-#IPADDRS_wlan0="192.0.2.3/24 2001:DB8::aede:48ff:fe71:f6f2/32"
-#ROUTES_wlan0="192.0.2.0/24 2001:DB8::/32"

=== modified file 'plugin-runner.c'
--- plugin-runner.c	2011-12-25 00:40:09 +0000
+++ plugin-runner.c	2011-11-24 21:12:35 +0000
@@ -171,7 +171,6 @@
 }
 
 /* Helper function for add_argument and add_environment */
-__attribute__((nonnull))
 static bool add_to_char_array(const char *new, char ***array,
 			      int *len){
   /* Resize the pointed-to array to hold one more pointer */
@@ -200,7 +199,6 @@
 }
 
 /* Add to a plugin's argument vector */
-__attribute__((nonnull(2)))
 static bool add_argument(plugin *p, const char *arg){
   if(p == NULL){
     return false;
@@ -209,7 +207,6 @@
 }
 
 /* Add to a plugin's environment */
-__attribute__((nonnull(2)))
 static bool add_environment(plugin *p, const char *def, bool replace){
   if(p == NULL){
     return false;
@@ -289,7 +286,6 @@
 }
 
 /* Prints out a password to stdout */
-__attribute__((nonnull))
 static bool print_out_password(const char *buffer, size_t length){
   ssize_t ret;
   for(size_t written = 0; written < length; written += (size_t)ret){
@@ -303,7 +299,6 @@
 }
 
 /* Removes and free a plugin from the plugin list */
-__attribute__((nonnull))
 static void free_plugin(plugin *plugin_node){
   
   for(char **arg = plugin_node->argv; *arg != NULL; arg++){
@@ -421,7 +416,6 @@
     { .name = NULL }
   };
   
-  __attribute__((nonnull(3)))
   error_t parse_opt(int key, char *arg, struct argp_state *state){
     errno = 0;
     switch(key){

=== modified file 'plugins.d/askpass-fifo.c'
--- plugins.d/askpass-fifo.c	2011-12-24 23:17:02 +0000
+++ plugins.d/askpass-fifo.c	2011-10-05 16:00:56 +0000
@@ -46,7 +46,6 @@
 
 
 /* Function to use when printing errors */
-__attribute__((format (gnu_printf, 3, 4)))
 void error_plus(int status, int errnum, const char *formatstring,
 		...){
   va_list ap;

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2011-12-30 17:14:15 +0000
+++ plugins.d/mandos-client.c	2011-11-28 22:18:37 +0000
@@ -170,14 +170,11 @@
 
 /* Function to use when printing errors */
 void perror_plus(const char *print_text){
-  int e = errno;
   fprintf(stderr, "Mandos plugin %s: ",
 	  program_invocation_short_name);
-  errno = e;
   perror(print_text);
 }
 
-__attribute__((format (gnu_printf, 2, 3)))
 int fprintf_plus(FILE *stream, const char *format, ...){
   va_list ap;
   va_start (ap, format);
@@ -205,13 +202,13 @@
 }
 
 /* Add server to set of servers to retry periodically */
-bool add_server(const char *ip, uint16_t port, AvahiIfIndex if_index,
-		int af){
+int add_server(const char *ip, uint16_t port, AvahiIfIndex if_index,
+	       int af){
   int ret;
   server *new_server = malloc(sizeof(server));
   if(new_server == NULL){
     perror_plus("malloc");
-    return false;
+    return -1;
   }
   *new_server = (server){ .ip = strdup(ip),
 			  .port = port,
@@ -219,7 +216,7 @@
 			  .af = af };
   if(new_server->ip == NULL){
     perror_plus("strdup");
-    return false;
+    return -1;
   }
   /* Special case of first server */
   if (mc.current_server == NULL){
@@ -236,9 +233,9 @@
   ret = clock_gettime(CLOCK_MONOTONIC, &mc.current_server->last_seen);
   if(ret == -1){
     perror_plus("clock_gettime");
-    return false;
+    return -1;
   }
-  return true;
+  return 0;
 }
 
 /* 
@@ -1033,11 +1030,8 @@
       if(ret == 0){
 	avahi_simple_poll_quit(mc.simple_poll);
       } else {
-	if(not add_server(ip, port, interface,
-			  avahi_proto_to_af(proto))){
-	  fprintf_plus(stderr, "Failed to add server \"%s\" to server"
-		       " list\n", name);
-	}
+	ret = add_server(ip, port, interface,
+			 avahi_proto_to_af(proto));
       }
     }
   }
@@ -1450,7 +1444,7 @@
 	  perror_plus("setenv");
 	  _exit(EX_OSERR);
 	}
-	ret = setenv("VERBOSITY", debug ? "1" : "0", 1);
+	ret = setenv("VERBOSE", debug ? "1" : "0", 1);
 	if(ret == -1){
 	  perror_plus("setenv");
 	  _exit(EX_OSERR);
@@ -1473,17 +1467,8 @@
 	  _exit(EX_OSERR);
 	}
 	free(delaystring);
-	if(connect_to != NULL){
-	  ret = setenv("CONNECT", connect_to);
-	  if(ret == -1){
-	    perror_plus("setenv");
-	    _exit(EX_OSERR);
-	  }
-	}
-	if(execl(fullname, direntry->d_name, mode, NULL) == -1){
-	  perror_plus("execl");
-	  _exit(EXIT_FAILURE);
-	}
+	ret = execl(fullname, direntry->d_name, mode, NULL);
+	perror_plus("execl");
       } else {
 	int status;
 	if(TEMP_FAILURE_RETRY(waitpid(hook_pid, &status, 0)) == -1){
@@ -1608,7 +1593,7 @@
 	.group = 2 },
       { .name = "retry", .key = 132,
 	.arg = "SECONDS",
-	.doc = "Retry interval used when denied by the Mandos server",
+	.doc = "Retry interval used when denied by the mandos server",
 	.group = 2 },
       { .name = "network-hook-dir", .key = 133,
 	.arg = "DIR",
@@ -1686,6 +1671,8 @@
 	argp_state_help(state, state->out_stream,
 			ARGP_HELP_USAGE | ARGP_HELP_EXIT_ERR);
       case 'V':			/* --version */
+	fprintf_plus(state->out_stream,
+		     "Mandos plugin mandos-client: ");
 	fprintf_plus(state->out_stream, "%s\n", argp_program_version);
 	exit(argp_err_exit_status);
 	break;

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2011-12-27 03:56:39 +0000
+++ plugins.d/mandos-client.xml	2011-11-27 14:44:28 +0000
@@ -583,23 +583,7 @@
 	  <listitem>
 	    <para>
 	      This will be the same as the <option>--delay</option>
-	      option passed to <command>&COMMANDNAME;</command>.  Is
-	      only set if <envar>MODE</envar> is
-	      <quote><literal>start</literal></quote> or
-	      <quote><literal>stop</literal></quote>.
-	    </para>
-	  </listitem>
-	</varlistentry>
-	<varlistentry>
-	  <term><envar>CONNECT</envar></term>
-	  <listitem>
-	    <para>
-	      This will be the same as the <option>--connect</option>
-	      option passed to <command>&COMMANDNAME;</command>.  Is
-	      only set if <option>--connect</option> is passed and
-	      <envar>MODE</envar> is
-	      <quote><literal>start</literal></quote> or
-	      <quote><literal>stop</literal></quote>.
+	      option passed to <command>&COMMANDNAME;</command>.
 	    </para>
 	  </listitem>
 	</varlistentry>

=== modified file 'plugins.d/password-prompt.c'
--- plugins.d/password-prompt.c	2011-12-25 00:40:09 +0000
+++ plugins.d/password-prompt.c	2011-10-09 12:32:13 +0000
@@ -72,18 +72,7 @@
 /* Needed for conflict resolution */
 const char plymouth_name[] = "plymouthd";
 
-__attribute__((format (gnu_printf, 2, 3), nonnull(1)))
-int fprintf_plus(FILE *stream, const char *format, ...){
-  va_list ap;
-  va_start (ap, format);
-  
-  TEMP_FAILURE_RETRY(fprintf(stream, "Mandos plugin %s: ",
-			     program_invocation_short_name));
-  return TEMP_FAILURE_RETRY(vfprintf(stream, format, ap));
-}
-
 /* Function to use when printing errors */
-__attribute__((format (gnu_printf, 3, 4)))
 void error_plus(int status, int errnum, const char *formatstring,
 		...){
   va_list ap;
@@ -96,7 +85,8 @@
     fprintf(stderr, "Mandos plugin %s: ",
 	    program_invocation_short_name);
     vfprintf(stderr, formatstring, ap);
-    fprintf(stderr, ": %s\n", strerror(errnum));
+    fprintf(stderr, ": ");
+    fprintf(stderr, "%s\n", strerror(errnum));
     error(status, errno, "vasprintf while printing error");
     return;
   }
@@ -119,7 +109,6 @@
      from the terminal.  Password-prompt will exit if it detects
      plymouth since plymouth performs the same functionality.
    */
-  __attribute__((nonnull))
   int is_plymouth(const struct dirent *proc_entry){
     int ret;
     int cl_fd;
@@ -139,7 +128,7 @@
     ret = asprintf(&cmdline_filename, "/proc/%s/cmdline",
 		   proc_entry->d_name);
     if(ret == -1){
-      error_plus(0, errno, "asprintf");
+      error(0, errno, "asprintf");
       return 0;
     }
     
@@ -148,7 +137,7 @@
     free(cmdline_filename);
     if(cl_fd == -1){
       if(errno != ENOENT){
-	error_plus(0, errno, "open");
+	error(0, errno, "open");
       }
       return 0;
     }
@@ -165,7 +154,7 @@
 	if(cmdline_len + blocksize + 1 > cmdline_allocated){
 	  tmp = realloc(cmdline, cmdline_allocated + blocksize + 1);
 	  if(tmp == NULL){
-	    error_plus(0, errno, "realloc");
+	    error(0, errno, "realloc");
 	    free(cmdline);
 	    close(cl_fd);
 	    return 0;
@@ -178,7 +167,7 @@
 	sret = read(cl_fd, cmdline + cmdline_len,
 		    cmdline_allocated - cmdline_len);
 	if(sret == -1){
-	  error_plus(0, errno, "read");
+	  error(0, errno, "read");
 	  free(cmdline);
 	  close(cl_fd);
 	  return 0;
@@ -187,7 +176,7 @@
       } while(sret != 0);
       ret = close(cl_fd);
       if(ret == -1){
-	error_plus(0, errno, "close");
+	error(0, errno, "close");
 	free(cmdline);
 	return 0;
       }
@@ -223,7 +212,7 @@
   int ret;
   ret = scandir("/proc", &direntries, is_plymouth, alphasort);
   if (ret == -1){
-    error_plus(1, errno, "scandir");
+    error(1, errno, "scandir");
   }
   free(direntries);
   return ret > 0;
@@ -260,7 +249,6 @@
       { .name = NULL }
     };
     
-    __attribute__((nonnull(3)))
     error_t parse_opt (int key, char *arg, struct argp_state *state){
       errno = 0;
       switch (key){
@@ -302,7 +290,7 @@
     case ENOMEM:
     default:
       errno = ret;
-      error_plus(0, errno, "argp_parse");
+      error(0, errno, "argp_parse");
       return EX_OSERR;
     case EINVAL:
       return EX_USAGE;
@@ -326,7 +314,7 @@
   
   if(tcgetattr(STDIN_FILENO, &t_old) != 0){
     int e = errno;
-    error_plus(0, errno, "tcgetattr");
+    error(0, errno, "tcgetattr");
     switch(e){
     case EBADF:
     case ENOTTY:
@@ -339,17 +327,17 @@
   sigemptyset(&new_action.sa_mask);
   ret = sigaddset(&new_action.sa_mask, SIGINT);
   if(ret == -1){
-    error_plus(0, errno, "sigaddset");
+    error(0, errno, "sigaddset");
     return EX_OSERR;
   }
   ret = sigaddset(&new_action.sa_mask, SIGHUP);
   if(ret == -1){
-    error_plus(0, errno, "sigaddset");
+    error(0, errno, "sigaddset");
     return EX_OSERR;
   }
   ret = sigaddset(&new_action.sa_mask, SIGTERM);
   if(ret == -1){
-    error_plus(0, errno, "sigaddset");
+    error(0, errno, "sigaddset");
     return EX_OSERR;
   }
   /* Need to check if the handler is SIG_IGN before handling:
@@ -358,37 +346,37 @@
   */
   ret = sigaction(SIGINT, NULL, &old_action);
   if(ret == -1){
-    error_plus(0, errno, "sigaction");
+    error(0, errno, "sigaction");
     return EX_OSERR;
   }
   if(old_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGINT, &new_action, NULL);
     if(ret == -1){
-      error_plus(0, errno, "sigaction");
+      error(0, errno, "sigaction");
       return EX_OSERR;
     }
   }
   ret = sigaction(SIGHUP, NULL, &old_action);
   if(ret == -1){
-    error_plus(0, errno, "sigaction");
+    error(0, errno, "sigaction");
     return EX_OSERR;
   }
   if(old_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGHUP, &new_action, NULL);
     if(ret == -1){
-      error_plus(0, errno, "sigaction");
+      error(0, errno, "sigaction");
       return EX_OSERR;
     }
   }
   ret = sigaction(SIGTERM, NULL, &old_action);
   if(ret == -1){
-    error_plus(0, errno, "sigaction");
+    error(0, errno, "sigaction");
     return EX_OSERR;
   }
   if(old_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGTERM, &new_action, NULL);
     if(ret == -1){
-      error_plus(0, errno, "sigaction");
+      error(0, errno, "sigaction");
       return EX_OSERR;
     }
   }
@@ -402,7 +390,7 @@
   t_new.c_lflag &= ~(tcflag_t)ECHO;
   if(tcsetattr(STDIN_FILENO, TCSAFLUSH, &t_new) != 0){
     int e = errno;
-    error_plus(0, errno, "tcsetattr-echo");
+    error(0, errno, "tcsetattr-echo");
     switch(e){
     case EBADF:
     case ENOTTY:
@@ -472,7 +460,7 @@
 	sret = write(STDOUT_FILENO, buffer + written, n - written);
 	if(sret < 0){
 	  int e = errno;
-	  error_plus(0, errno, "write");
+	  error(0, errno, "write");
 	  switch(e){
 	  case EBADF:
 	  case EFAULT:
@@ -494,7 +482,7 @@
       sret = close(STDOUT_FILENO);
       if(sret == -1){
 	int e = errno;
-	error_plus(0, errno, "close");
+	error(0, errno, "close");
 	switch(e){
 	case EBADF:
 	  status = EX_OSFILE;
@@ -510,7 +498,7 @@
     if(sret < 0){
       int e = errno;
       if(errno != EINTR and not feof(stdin)){
-	error_plus(0, errno, "getline");
+	error(0, errno, "getline");
 	switch(e){
 	case EBADF:
 	  status = EX_UNAVAILABLE;
@@ -539,7 +527,7 @@
     fprintf(stderr, "Restoring terminal attributes\n");
   }
   if(tcsetattr(STDIN_FILENO, TCSAFLUSH, &t_old) != 0){
-    error_plus(0, errno, "tcsetattr+echo");
+    error(0, errno, "tcsetattr+echo");
   }
   
   if(quit_now){
@@ -547,7 +535,7 @@
     old_action.sa_handler = SIG_DFL;
     ret = sigaction(signal_received, &old_action, NULL);
     if(ret == -1){
-      error_plus(0, errno, "sigaction");
+      error(0, errno, "sigaction");
     }
     raise(signal_received);
   }

=== modified file 'plugins.d/plymouth.c'
--- plugins.d/plymouth.c	2011-12-25 00:40:09 +0000
+++ plugins.d/plymouth.c	2011-10-05 16:00:56 +0000
@@ -75,7 +75,6 @@
 }
 
 /* Function to use when printing errors */
-__attribute__((format (gnu_printf, 3, 4)))
 void error_plus(int status, int errnum, const char *formatstring,
 		...){
   va_list ap;
@@ -154,7 +153,6 @@
   return true;
 }
 
-__attribute__((nonnull (2, 3)))
 bool exec_and_wait(pid_t *pid_return, const char *path,
 		   const char **argv, bool interruptable,
 		   bool daemonize){
@@ -214,7 +212,6 @@
   return false;
 }
 
-__attribute__((nonnull))
 int is_plymouth(const struct dirent *proc_entry){
   int ret;
   {

=== modified file 'plugins.d/splashy.c'
--- plugins.d/splashy.c	2011-12-24 23:17:02 +0000
+++ plugins.d/splashy.c	2011-10-05 16:00:56 +0000
@@ -61,7 +61,6 @@
 int signal_received;
 
 /* Function to use when printing errors */
-__attribute__((format (gnu_printf, 3, 4)))
 void error_plus(int status, int errnum, const char *formatstring,
 		...){
   va_list ap;

=== modified file 'plugins.d/usplash.c'
--- plugins.d/usplash.c	2011-12-24 23:17:02 +0000
+++ plugins.d/usplash.c	2011-10-05 16:00:56 +0000
@@ -58,7 +58,6 @@
 const char usplash_name[] = "/sbin/usplash";
 
 /* Function to use when printing errors */
-__attribute__((format (gnu_printf, 3, 4)))
 void error_plus(int status, int errnum, const char *formatstring,
 		...){
   va_list ap;

